#!/bin/sh
CROND_PATH=/usr/sbin
DAEMON=crond
LOG_FILE=/var/log/crond.log
CROND_SPOOL_DIR=/var/spool/cron/crontabs


case $1 in
	start)
		if [ ! -d $CROND_SPOOL_DIR ];then
			echo $CROND_SPOOL_DIR
			mkdir -p  $CROND_SPOOL_DIR
			chmod -R 755 $CROND_SPOOL_DIR
		fi
		if [ ! -f /var/spool/cron/crontabs/root ];then
			echo '*/1 * * * * /etc/init.d/nas/everyminuteexec ' >> "$CROND_SPOOL_DIR/root"                     
			echo '10 * * * * /etc/init.d/nas/everyhourexec' >> "$CROND_SPOOL_DIR/root"                     
			echo '20 0 * * * /etc/init.d/nas/everydayexec'  >> "$CROND_SPOOL_DIR/root" 
			echo '*/1 * * * * /etc/init.d/nas/winbind start' >> "$CROND_SPOOL_DIR/root"
			echo '*/30 * * * * ntpdate time.windows.com' >> "$CROND_SPOOL_DIR/root"
		fi
		PID=`pidof crond`
		if [ -z $PID ]; then
			$CROND_PATH/$DAEMON -L $LOG_FILE
		fi
		exit 0
		;;
	stop)
		killall $DAEMON 2> /dev/null
		exit 0
		;;
	restart)
		$0 stop
		sleep 2
		$0 start
		exit 0
		;;
	*)
		echo $0 start|stop|restart
		exit 1
		;;
esac
