#!/bin/sh
#PRINT_CAP_FILE=/printcap
#LPPERMS_FILE=/lpd.perms
PRINT_CAP_FILE=/mnt/base/etc/lprng/printcap
LPPERMS_FILE=/mnt/base/etc/lprng/lpd.perms
HOST_ALLOW=/tmp/hosts.allow
MX=0
FLAG=0
HOST_FLAG=0
HOSTS=

parse()
{
	REMOTE_IP=
	REMOTE_HOST=
	i=0
	j=0
	#echo host=$HOSTS
	if [ "XX$HOSTS" == "XX" ];then
		REMOTE_IP=all
		REMOTE_HOST=all
		echo -e "REMOTE_IP=$REMOTE_IP\nREMOTE_HOST=$REMOTE_HOST" > $HOST_ALLOW 
	elif [ "XX$HOSTS" == "XXall" ];then
		REMOTE_IP=all
		REMOTE_HOST=all
		echo -e "REMOTE_IP=$REMOTE_IP\nREMOTE_HOST=$REMOTE_HOST" > $HOST_ALLOW 
	else	
	echo $HOSTS | awk -F',' 'BEGIN{i=1}{while(1){if($i=="")break;print $i;i++}}'| while read LINE
	do
		TMP=`echo $LINE | grep '[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}'`
		if [ ! -z $TMP ];then  ##ip address
			i=`expr $i + 1`
			if [ $i -eq 1 ];then
				REMOTE_IP=$REMOTE_IP$TMP
		 	elif [ $i -gt 1 ];then
			 	REMOTE_IP=$REMOTE_IP",$TMP"
			fi
		else	##host name
			j=`expr $j + 1`
			if [ $j -eq 1 ];then
				REMOTE_HOST=$REMOTE_HOST"$LINE"
			elif [ $j -gt 1 ]; then
			 	REMOTE_HOST=$REMOTE_HOST",$LINE"
			fi
		fi
		echo -e "REMOTE_IP=$REMOTE_IP\nREMOTE_HOST=$REMOTE_HOST" > $HOST_ALLOW
	done
	fi
}

if [ ! -f $LPPERMS_FILE ]; then
	echo "check for $LPPERMS_FILE existence."
	exit 1
fi
##############printcap file#######################
if [ ! -z $1 ]; then
	if [ -f $PRINT_CAP_FILE ];then
		MX=$1
		#integer or not
		INTEGER=`echo $MX|grep -q '^[-]\?[0-9]\+$' && echo yes || echo no`
		[ "XX$INTEGER" == "XXyes" ] && sed -i '/:mx=/c\\t:mx='$1':\\' $PRINT_CAP_FILE	
	fi
fi
###################################################

#look up args
for VAL in $@
do
if [ XX$VAL == XXallow ]; then
	ACCESS=allow
elif [ XX$VAL == XXdeny ];then 
	ACCESS=deny
fi

if [ $HOSTS == 0 ]; then
	HOSTS=`echo $VAL | awk -F'hosts=' '{print $2}'`	
fi
done

#put value into host.allow
parse
#include host.allow file
. $HOST_ALLOW
#echo "$REMOTE_IP | $REMOTE_HOST"

###############################lpd.perms file#############################
sed -i '/^[^#]/d' $LPPERMS_FILE
echo "DEFAULT ACCEPT" >>  $LPPERMS_FILE

if [ $ACCESS == allow ]; then
	if [ ! -z $REMOTE_IP ] &&  [ ! -z $REMOTE_HOST ]; then
		if [  XX$REMOTE_IP = XXall ] &&  [ XX$REMOTE_HOST = XXall ];then
			echo "DEFAULT ACCEPT" >  $LPPERMS_FILE
		else
			## Reject any connections from all besides REMOTEIP and REMOTEHOST
			echo "REJECT SERVICE=X NOT REMOTEIP=$REMOTE_IP REMOTEHOST=$REMOTE_HOST" >> $LPPERMS_FILE
			
			##Only accept Printing (P),spooling (LPR) ,Status (LPQ) and remove(LPRM) Request from REMOTEIP and REMOTEHOST
			echo "ACCEPT SERVICE=R,P,Q,M REMOTEIP=$REMOTE_IP REMOTEHOST=$REMOTE_HOST" >> $LPPERMS_FILE
		fi
	elif [ ! -z $REMOTE_IP ] &&  [ -z $REMOTE_HOST ]; then
		echo "REJECT SERVICE=X NOT REMOTEIP=$REMOTE_IP" >> $LPPERMS_FILE
		echo "ACCEPT SERVICE=R,P,Q,M REMOTEIP=$REMOTE_IP" >> $LPPERMS_FILE
	elif [ ! -z $REMOTE_HOST ] && [ -z $REMOTE_IP ]; then
		echo "REJECT SERVICE=X NOT REMOTEIP=$REMOTE_HOST" >> $LPPERMS_FILE
		echo "ACCEPT SERVICE=R,P,Q,M REMOTEHOST=$REMOTE_HOST" >> $LPPERMS_FILE
	elif [ -z $REMOTE_HOST ] && [ -z $REMOTE_IP ]; then
		#default accept from all request
		:
	fi
elif [ $ACCESS == deny ]; then
	if [ ! -z $REMOTE_IP ]  && [ ! -z $REMOTE_HOST ]; then
		if [  XX$REMOTE_IP = XXall ] &&  [ XX$REMOTE_HOST = XXall ]; then
			echo "REJECT SERVICE=X" >> $LPPERMS_FILE
		else 
			echo "REJECT SERVICE=X REMOTEIP=${REMOTE_IP} REMOTEHOST=$REMOTE_HOST" >> $LPPERMS_FILE 
		fi
	elif [ ! -z $REMOTE_IP ] && [ -z $REMOTE_HOST ]; then
		echo "REJECT SERVICE=X REMOTEIP=$REMOTE_IP" >> $LPPERMS_FILE
	elif [ ! -z $REMOTE_HOST ] && [ -z $REMOTE_IP ]; then
		echo "REJECT SERVICE=X REMOTEHOST=$REMOTE_HOST" >> $LPPERMS_FILE
	fi
fi
#########################################################################

#delte host.allow file
rm $HOST_ALLOW

#At last,restart lpd daemon
killall -HUP lpd
exit 0
