#!/bin/sh

DIRSTR=$1
NAMESTR=$2
RIGHTSTR=$3
APPMODE=$4

if [ $# -ne 4 ];then
        echo "Usage:$0 [path(s)] [name(s)] [right(s)] [appmode]"
        exit 1
fi

main(){
	FLAG=0
	if [ $APPMODE == 1 ] || [ $APPMODE == 2 ];then
		FLAG=1
	fi
	i=1
	while(true)
	do
		DIR=`echo "${DIRSTR}," | cut -d "," -f$i`
		if [ "XXX${DIR}" != "XXX" ]; then
			#del the last '/'...
			DIR=${DIR%%/}
			#clean the $DIR right
			noontec_cleanAcl "$DIR" $APPMODE
			#add default right for $DIR ...
			noontec_adddefaultacl "$DIR" 2 2 2 2 $FLAG
			let i++
			j=1
			while(true)
			do
				NAME=`echo "${NAMESTR}," | cut -d "," -f$j`
				RIGHT=`echo "${RIGHTSTR}," | cut -d "," -f$j`
				if [ "XXX${NAME}" != "XXX" -a "XXX${RIGHT}" != "XXX" ];then
					let j++
					nameid=`nametoid "$NAME"`
					root_defaultacl "$DIR" "$nameid" "$RIGHT" "$FLAG"
				else
					break
				fi
			done
		else
			break
		fi
	done
	exit 0
}

root_defaultacl(){
	dir=$1; name=$2; right=$3; flag=$4
	Pdir=`dirname ${dir}`
	echo "dir=$dir, name=$name, right=$right, flag=$flag"
	if [ "${dir}" != "/mnt/usb" ] && [ "${dir}" != "/mnt/iscsi" ] && [ "${Pdir}" != "/mnt/iscsi" ] && [ "${dir}" != "/mnt/hdd" ] && [ "${Pdir}" != "/mnt/hdd" ] && [ "${dir}" != "/mnt/iso" ] && [ "${Pdir}" != "/mnt/iso" ]; then
        	if [ $flag == 1 ]; then
                	argument="-R"
	        fi
		if [ "${name/@/}" != "$name" ];then
			type="g"; name=${name/@/}
		else
			type="u"
		fi
		if [ "$right" == "X" ];then
			argument="$argument -x"
			setfacl $argument $type:$name "$dir/"
			if [ -d "${dir}" ];then
				setfacl -d $argument $type:$name "$dir/"
			fi
		else
			argument="$argument -m"
			right=`highperm $right`
			setfacl $argument $type:"$name":$right "$dir/"
			if [ -d "${dir}" ];then
				setfacl -d $argument $type:"$name":$right "$dir/"
			fi
		fi
	fi
	return 0
}

#add default acl right...
noontec_adddefaultacl(){
	dir=$1; mask=$2; user=$3; group=$4; other=$5; flag=$6
	mask=`highperm $mask`; user=`highperm $user`; group=`highperm $group`; other=`highperm $other`
	if [ $flag == 1 ]; then 
		argument="-R -m"
	else
		argument="-m"
	fi
	setfacl $argument m::$mask,u::$user,g::$group,o::$other "${dir}/"
	if [ -d "${dir}" ];then
		setfacl -d $argument m::$mask,u::$user,g::$group,o::$other "$dir/"
	fi
	return 0
}

highperm(){
	right=$1
	case "${right}" in
		1)
			echo 5
			;;
		2)
			echo 7
			;;
		*)
			echo 0
			;;
	esac
	return 0
}

nametoid(){
	name=$1
	if [ "${name/@/}" != "$name" ];then
		echo $name
	else
		uid=`id -u "$name"`
		echo $uid
	fi
	return 0
}

#clean the acl right ...
noontec_cleanAcl(){
	dir=$1; appmode=$2
	if [ $appmode == 1 ];then
		args="-R -b"
	else
		args="-b"
	fi
	setfacl $args "$dir/"
	return 0
}

main
