// JavaScript Document
jQuery.cookie = function(name, value, options) {
	if (typeof value != 'undefined') { // name and value given, set cookie
		options = options || {};
		if (value === null) {
			value = '';
			options.expires = -1;
		}
		var expires = '';
		if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
			var date;
			if (typeof options.expires == 'number') {
				date = new Date();
				date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
			} else {
				date = options.expires;
			}
			expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
		}
		var path = options.path ? '; path=' + options.path : '';
		var domain = options.domain ? '; domain=' + options.domain : '';
		var secure = options.secure ? '; secure' : '';
		document.cookie = [name,'=',encodeURIComponent(value),expires,path,domain,secure].join('');
	}else { // only name given, get cookie
		var cookieValue = null;
		if (document.cookie && document.cookie != ''){
			var cookies = document.cookie.split(';');
			for (var i = 0; i < cookies.length; i++){
				var cookie = jQuery.trim(cookies[i]);
				// Does this cookie string begin with the name we want?
				if (cookie.substring(0, name.length + 1) == (name + '=')) {
					cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
					break;
				}
			}
		}
		return cookieValue;
   }
};
var Timer;
$.ajaxSetup({ cache: false });
function loadpage_notab(object,ajaxpage){
	if(object && ajaxpage){
		//标签可以与目标id一致,也可以不一致...
		var tab = arguments[2] ? arguments[2] : object ;
		$.post('/include/ajax/'+ajaxpage+'.php',
		{"tab":tab},function(rel){
			$('#'+object).html(rel);
		});
	}
}

function loadpage(obj){
	var pagename = arguments[1] ? arguments[1] : obj ;
	$.ajax({
		type:"POST",
		url:"/include/ajax/"+pagename+".php",
		data:"tab="+$("#tabul li.on").attr('sid') + '&k=' + Math.random(),
		beforeSend:function(t){
			$('#'+obj).height(100);
			$('#'+obj).html("").css({"background":"url(/images/loading.gif) center center no-repeat"});
		},
		success:function(data){
			$('#'+obj).css({"background":"none"});
			$('#'+obj).html(data);
		}
	});
}

function PageLoadAjax(obj){
	var pagename = arguments[1] ? arguments[1] : obj ;
	var baseli = $("#tabul li");
	if(baseli.length > 0){
		baseli.hover(
			function(){
				if(!$(this).hasClass("on")){
					$(this).removeClass("hover").addClass("hover");
				}
			},
			function(){$(this).removeClass("hover");}
		);
		baseli.click(function(){
			$(this).removeClass().addClass("on").siblings("li").removeClass("on");
			clearTimeout(Timer);//清除所有的Timeout;
			clearInterval(Timer);
			loadpage(obj,pagename);//预加载模块
		});
	}
	loadpage(obj,pagename);//预加载模块
}

//得到url地址栏参数的通用函数...
function GetQueryString(name){
	var reg = new RegExp("(^|&)"+name+"=([^&]*)(&|$)");      
	var r = window.location.search.substr(1).match(reg);      
	if(r!=null) return unescape(r[2]); return null;      
}

function saveStat(obj){
	var pos = arguments[1] ? arguments[1] : 0 ;
	var text = $(obj).attr('lang') ? $(obj).attr('lang') : $(obj).text();
	var container = $(obj).siblings('.showAction');
	if(container.length > 0){
		container.html(text+"...").show();
	}else{	
		var statdiv = "<span id='saving' class='saving'>"+text+"...</span>";
		if($('#saving').length > 0) $('#saving').remove();
		switch(pos){
			case 0:
				$(obj).attr('disabled','disabled').before(statdiv);
				break;
			case 1:
				$(obj).attr('disabled','disabled').after(statdiv);
				break;		
		}
	}
}

function removeStat(obj){
	var container = $(obj).siblings('.showAction');
	if(container.length > 0){
		container.html("").hide();
	}else{
		var saving = $('#saving');
		if(saving.length > 0) saving.remove();
		$(obj).removeAttr('disabled');
	}
}

function answer(obj){
	var text = $(obj).attr('lang');
	if($('#helpTips').length < 1){
		$(obj).append("<div id='helpTips' class='mousetips'>"+text+"</div>");
	}else{
		$('#helpTips').show().html(text);
	}
}

function removeAnswer(){
	if($('#helpTips').length > 0){
		$('#helpTips').remove();
	}
}

//从指定数组查找给定的值...
function Findtext(obj,arr){
	for(b in arr){
		if(arr[b] == obj){
			return true;
		}
	}
	return false;
}

function Exists(cell,array){
	if(!cell || !array){ return false; }
	for(i in array){
		if(array[i].indexOf(cell) == 0){
			array.splice(i,1);
		}
	}
}
//判断是否为整型数
function isInt(str){
	var reg = /^(-|\+)?\d+$/;
	return reg.test(str);
}
//判断是否为浮点型数
function isFloat(str){
	if(isInt(str)) return true;
	var reg = /^(-|\+)?\d+\.\d*$/;
	return reg.test(str);
}

function chkpasswd(obj1, obj2, arg){
	var Max = Min = 0;
	if(arg.indexOf("-") > -1){
		var numy = arg.split("-");
		Min = Math.min(parseInt(numy[0]),parseInt(numy[1]));
		Max = Math.max(parseInt(numy[0]),parseInt(numy[1]));
	}
	var lang1 = $(obj1).attr('lang'), lang2 = $(obj2).attr('lang');
	$(obj1).blur(function(){
		if($(this).val() == '' || $(this).val().length < Min || $(this).val().length > Max){
			alert(lang); inputError(this,1); return $(this).focus();
		}else{ inputError(this,0); }
	});
	$(obj2).blur(function(){
		if($(obj1).val() == ''){
			inputError(obj1,1);
			return $(obj1).focus();
		}else{ inputError(obj1,0); }
		if($(this).val() == '' || $(this).val() != $(obj1).val()){
			alert(lang); inputError(this,1); return $(this).focus();
		}else{ inputError(this,0); }
	});
}

function checkpwd(obj){
	var thisval = $(obj).val();
	var num = arguments[1] ? arguments[1] : "0-255" ;
	var Max = Min = 0;
	if(num.indexOf("-") > -1){
		var numy = num.split('-');
		Min = Math.min(parseInt(numy[0]),parseInt(numy[1]));
		Max = Math.max(parseInt(numy[0]),parseInt(numy[1]));
	}
	var lang = $(obj).attr('lang');
	if($(obj).val() == '' || $(obj).val().length < Min || $(obj).val().length > Max){
		alert(lang);inputError(obj,1);				
	}else{ inputError(obj,0); }
}

function checklen(obj1,obj2){
	var obj1 = $('input[name='+obj1+']');
	var obj2 = $('input[name='+obj2+']');
	if(obj1.val() != obj2.val()){
		alert(obj2.attr('lang'));inputError(obj2,1);
	}else{
		inputError(obj2,0);
	}
}

function checknum(obj){
	thisnum = $(obj).val();
	var num = arguments[1] ? arguments[1] : "0-255" ;
	var Max = Min = 0;
	if(num.indexOf("-") > -1){
		var numy = num.split('-');
		Min = Math.min(parseInt(numy[0]),parseInt(numy[1]));
		Max = Math.max(parseInt(numy[0]),parseInt(numy[1]));
	}
	if(thisnum != ""){ inputNumber(obj,Min); }//清除input中的数字之外的字符
	$(obj).unbind('blur').blur(function(){
		var lang = $(this).attr('lang');
		if($(this).val() == '' || $(this).val() < Min){
			if(typeof(lang) == 'undefined' || lang == ''){
				$(this).val(Min);
			}else{
				alert(lang);inputError(this,1);
			}			
		}else if($(this).val() > Max){
			if(typeof(lang) == 'undefined' || lang == ''){
				$(this).val(Max);
			}else{
				alert(lang);inputError(this,1);
			}					
		}else{ inputError(this,0); }
	});
	if(thisnum.length > 3){
		$(obj).next('input[@type=text]').select();
	}
    //press Enter to onload sys
	document.onkeydown = function(e){
		if(!e) e = window.event;//火狐中是 window.event
		if((e.keyCode || e.which) == 110 || (e.keyCode || e.which) == 220){
			$(obj).next('input[@type=text]').select();
		}
	}
}

function checkip(obj){
	ipaddr = $(obj).val();
	str = ipaddr.match(/(\d+)\.(\d+)\.(\d+)\.(\d+)/g);
	if (str == null){
		inputError(obj,1);
		return false;
	}else if(RegExp.$1>254 || RegExp.$2>255 || RegExp.$3>=255 || RegExp.$4>254){
		inputError(obj,1);
		return false;
	}else{
		inputError(obj,0);
		return true;
	}
}

//input error deal....
function inputError(obj,error){
	if(error == 1){
		$(obj).css("border-color","#F00");
		return false;
	}else if(error == 0){
		$(obj).css("border-color","#666");
	}
}

function inputNumber(obj){
	var al = arguments[1] ? arguments[1] : 0 ;
	if($(obj).val() != ''){
		al = $(obj).val().replace(/\D/g,'');		
	}
	if(al == ''){
		$(obj).val(al);
	}else{
		$(obj).val(parseInt(al));
	}
}

function hostnameformat(obj){
	 var txt = obj.value;
	 txt.replace(/[^a-zA-Z0-9_-]+/, function (char, index, val) {//匹配第一次非数字字符
		obj.value = val.replace(/[^a-zA-Z0-9_-]/g, "");//将非数字字符替换成""
		var rtextRange = null;
		if (obj.setSelectionRange) {
			obj.setSelectionRange(index, index);
		} else {//支持ie
			rtextRange = obj.createTextRange();
			rtextRange.moveStart('character', index);
			rtextRange.collapse(true);
			rtextRange.select();
		}
	});
}

function inputformat(obj){
	 var txt = obj.value;
	 txt.replace(/[^\u4E00-\u9FA5a-zA-Z0-9_-]+/, function (char, index, val) {//匹配第一次非数字字符
		obj.value = val.replace(/[^\u4E00-\u9FA5a-zA-Z0-9_-]/g, "");//将非数字字符替换成""
		var rtextRange = null;
		if (obj.setSelectionRange) {
			obj.setSelectionRange(index, index);
		} else {//支持ie
			rtextRange = obj.createTextRange();
			rtextRange.moveStart('character', index);
			rtextRange.collapse(true);
			rtextRange.select();
		}
	});
}

function checkpass(obj){
	var v = $(obj);
	var l = arguments[1] ? arguments[1] : 3 ;
	if(v.val().length < l){
		inputError(v,1); return false;
	}else{
		inputError(v,0); return true;
	}
}

Array.max=function(array){
    return Math.max.apply(Math,array);
}

Array.min=function(array){
    return Math.min.apply(Math,array);
}

function Len(str){
	var sum=0; 
	for(i=0;i<str.length;i++){ 
		if((str.charCodeAt(i)>=0) && (str.charCodeAt(i)<=255)){
			sum = sum+1;
		}else{
			sum = sum+2;
		}
	} 
	return sum;
}

//求两个数组的差集...
function minus(a, b){
	for(i in b){
		for(j in a){ if(a[j] == b[i]) a.splice(j,1); }
	}
	return a;
}

function checkmail(obj){
	var value = $(obj).val();
	if(value != ''){
		var pattern =/^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
		var flag = pattern.test(value);
		if(!flag){
			inputError(obj,1);
		}else{
			inputError(obj,0);
		}
	}else{
		inputError(obj,0);
	}
}

function usewbox(obj){
	var dataType = $(obj).attr('dataType');
	var data = $(obj).attr('data');
	var url = $(obj).attr('url');
	var title = $(obj).attr('title');
	if(data){
		$(obj).wBox({type:"post", title:title, requestType:dataType, data:data, target:url});
	}else{
		$(obj).wBox({title:title, requestType:dataType, target:url});
	}
}

function checkport(obj){
	var result = false;
	if($(obj).val() != ''){
		var oldport = $(obj).attr('oldport');
		if($(obj).val() != oldport){
			$.ajax({
				type	: 'POST',
				url		: '/include/ajax/ajaxdata.php',
				data	: {'checkport': $(obj).val()},
				async	: false,
				success	: function(data){
					if(data != 1){
						alert(data); inputError(obj,1);
					}else{
						inputError(obj,0);
						result = true;
					}
				}
			});
		}else{
			inputError(obj,0); result = true;
		}
	}
	return result;
}

function minmax(obj){
	var thisnum = $(obj).val();
	var num = arguments[1] ? arguments[1] : "0" ;
	var Max = Min = 0;
	if(num.indexOf("-") > -1){
		var numy = num.split('-');
		Min = Math.min(parseInt(numy[0]),parseInt(numy[1]));
		Max = Math.max(parseInt(numy[0]),parseInt(numy[1]));
	}
	//清除input中的数字之外的字符
	thisnum = thisnum.replace(/\D/g,'');
	$(obj).val(thisnum);
	//判断取值范围
	if(thisnum != "" && Max != 0){
		if(thisnum > Max){
			$(obj).val(Max);
		}else if(thisnum < Min){
			$(obj).val(Min);
		}
	}
}

function Jpage(srcid,pageid){
	var ctrl = $('#'+pageid);
	var perobj = ctrl.find('[name=per]');
	var iskey = arguments[3] ? arguments[3] : false ; //搜索的关键字...
	var iscookie = arguments[2] ? arguments[2] : false ;
	var Filter = arguments[4] ? arguments[4] : false ;
	
	if(perobj.length > 0){
		var per = perobj.val();
		perobj.change(function(){ Jpage(srcid,pageid,iscookie,iskey,Filter); });
	}else{
		var per = 8;
	}
	var searchobj = '';
	if(iskey != false && $('#'+iskey).length > 0){
		searchobj = $('#'+iskey).find('[name=search]').val();
		$('#'+iskey+' em').click(function(){ Jpage(srcid,pageid,iscookie,iskey,Filter); });
	}
	if(searchobj == ''){
		var trs = $('#'+srcid).children('tr');
		//过滤掉特殊的行...		
		if(Filter != false) trs = $('#'+srcid).children('tr:not(".'+Filter+'")');
		//过滤完成...
		trs.hide();//首先隐藏所有的行...
	}else{
		var trs = $('#'+srcid).children('tr[key*="'+searchobj+'"]');
		if(Filter != false) trs = $('#'+srcid).children('tr[key*="'+searchobj+'"]:not(".'+Filter+'")');
		$('#'+srcid).children('tr').hide();//首先隐藏所有的行...
	}
	var total = trs.length;
	var pages = Math.ceil(total / per);
	pages = pages==0 ? 1 : pages;
		
	if($.cookie('page') && iscookie){
		var page = $.cookie('page') <= pages && $.cookie('page') > 0 ? $.cookie('page') : 1 ;
	}else{ var page = 1; }
	
	$.cookie('page',page);//设置当前页的cookie;
	for(i=(page-1)*per;i<page*per;i++){
		trs.eq(i).show();
	}
	ctrl.find('.total').html(total); ctrl.find('[name=page]').val(page+' / '+pages);
	if(page > 1){
		ctrl.find('[rel=prev]').removeClass().addClass('prev');
		ctrl.find('[rel=prev]').unbind('click').click(function(){
			var currentpage = parseInt($.cookie('page'));
			$.cookie('page',currentpage-1);//设置当前页的cookie ;
			Jpage(srcid,pageid,true,iskey,Filter);
		});
		ctrl.find('[rel=first]').removeClass().addClass('first');
		ctrl.find('[rel=first]').unbind('click').click(function(){
			$.cookie('page',1);//设置当前页的cookie ;
			Jpage(srcid,pageid,true,iskey,Filter);
		});
	}else{
		ctrl.find('[rel=prev]').removeClass().addClass('prevgray');
		ctrl.find('[rel=first]').removeClass().addClass('firstgray');
	}
	if(page < pages){
		ctrl.find('[rel=next]').removeClass().addClass('next');
		ctrl.find('[rel=next]').unbind('click').click(function(){
			var currentpage = parseInt($.cookie('page'));
			$.cookie('page',currentpage+1);//设置当前页的cookie ;
			Jpage(srcid,pageid,true,iskey,Filter);
		});
		ctrl.find('[rel=last]').removeClass().addClass('last');
		ctrl.find('[rel=last]').unbind('click').click(function(){
			$.cookie('page',pages);//设置当前页的cookie ;
			Jpage(srcid,pageid,true,iskey,Filter);
		});
	}else{
		ctrl.find('[rel=next]').removeClass().addClass('nextgray');
		ctrl.find('[rel=last]').removeClass().addClass('lastgray');
	}
}

//只能选择一个同名的选项...
function chooseOne(cb){
	 var obj = document.getElementsByName(cb.name);
	 if(cb.checked == false){
		 cb.checked = false;
	 }else{
		 for (j=0; j<obj.length; j++){   
			 if (obj[j]!=cb){
				 obj[j].checked = false;
			 }else{
				 obj[j].checked = true;
			 }
		 }
	 }
}

function selectAll(obj)
{
	var tmp = arguments[1] ? arguments[1] : "userlist" ;
	var objlist = $("input[name="+tmp+"]:not(:disabled)");
	if($(obj).attr("checked")){
	    objlist.attr("checked",true);
	}else{
	    objlist.removeAttr("checked");
	}
}

function togClass(obj){
	var parentobj = $(obj).parent('em');
	if(parentobj.hasClass('checked')){
		parentobj.removeClass('checked').find('input[type=checkbox]').attr('checked',false);
	}else{
		parentobj.addClass('checked').find('input[type=checkbox]').attr('checked',true);
	}
}

$(window).resize(function(){ setPageHeight(); });

function setPageHeight(){
	var header = $('.menuhead');
	var mainbox = $('.mainbox');
	if(header.length > 0){
		var h = $(window).height() - header.height() - 18;
	}else{
		var h = $(window).height() - 18;
	}
	if(mainbox.length > 0) mainbox.height(h);
}

function returntime(){
	$('#getTime').html(totaltime);
	if(totaltime > 0){
		totaltime--;
		Timer = setTimeout('returntime()',1000);
	}else{
		clearTimeout(Timer);
		top.window.location.reload();
	}
}

function logout(a){
	$.post('/include/ajax/ajaxdata.php',
	{'webloginout':1,'loginName':a},function(rel){
		 top.window.location.reload();
	});
}

var selectme = function(obj){
	var tName = $(obj).get(0).tagName;
	if(tName != 'SELECT'){
		$("#lang span").html($(obj).html());
		$(obj).parent('div').slideUp('up',function(){key=0;});
		var lang = $(obj).attr('rel');
	}else{
		var lang = $(obj).val();
	}
	var myDate = new Date();
	var mm,md,mh,mi,ms;
	mm = myDate.getMonth(); if(mm < 10) mm = '0' + mm;
	md = myDate.getDate(); if(md < 10) md = '0' + md;
	mh = myDate.getHours(); if(mh < 10) mh = '0' + mh;
	mi = myDate.getMinutes(); if(mi < 10) mi = '0' + mi;
	ms = myDate.getSeconds(); if(ms < 10) ms = '0' + ms;
	var datestr = myDate.getFullYear()+'-'+mm+'-'+md+' '+mh+':'+mi+':'+ms;
	$.post("/include/ajax/ajaxdata.php",
	{"langcookie":lang,'langTime':datestr},function(rel){
		if(tName == 'SELECT' && $(obj).attr('name') == 'changelang'){
			window.top.frames["head"].location.reload();
			window.top.frames["list"].location.reload();
			window.top.frames["main"].location.reload();
		}else{
			top.window.location.reload();
		}
	});
}

var stopnoise = function(){
	$.ajax({
		type	:'POST',
		url		:'/include/ajax/ajaxdata.php',
		data	:{'stopnoise':1}
	});
}

var ncount = 0;
var nmax = 1;
var Gnet = 0;
var FreshNet = function(){
	if($("#eth_public").length > 0){
		if(ncount < nmax){
			ncount++;
		}else{
			setTimeout('FreshNet()', 3000);
			return false;
		}
		var loss = ["> 50%", "50%", "25%", "0%"];
		$.ajax({
			type	:'POST',
			url		:'/include/ajax/ajaxdata.php',
			data	:{'checknetstat':1},
			complete:function(XMLHttpRequest){
				var ots = eval("("+XMLHttpRequest.responseText+")");
				if(typeof(ots) == "object"){
					$("#eth_public").html(ots.ip);
					//7表示丢包率达50%
					if(ots.ps < 7){
						$("#eth_public").attr("class","bad");
						$("#eth_public").attr("title","loss packets "+loss[0]);
						Gnet = 0;
					}else{
						$("#eth_public").attr("class","good");
						$("#eth_public").attr("title","loss packets "+loss[ots.ps-6]);
						Gnet = 1;
					}
				}
				setTimeout('FreshNet()', 3000);
				ncount--;
			}
		});
	}else{
		return false;
	}
}

function show_dk_size(dk, target){
	var diskspath = $(dk).val();
	if(diskspath != ''){
		$.post('/include/ajax/ajaxdata.php', {"mysqlfunction":3,"diskspath":diskspath},function(rel){
			$(target).text(rel);
		});
	}else{
		$(target).text('---');
	}
}

var setdisabled = function(){
	$("[class=devbtn][disabled]").attr('class','btndis').unbind('click').removeAttr('onclick');
}

$(function(){
	FreshNet();
	setPageHeight();
	setdisabled();
});